#include "integer.h"
#include "compgmp.h"
// extern "C" {
// #include "gmp.h"
// }

// const Integer powmod(const Integer& n, const Integer& e, const Integer& f)
// {
//     Integer Res;
//     mpz_powm ((mpz_ptr)&(Res.gmp_rep), (mpz_ptr)&(n.gmp_rep), (mpz_ptr)&(e.gmp_rep), (mpz_ptr)&(f.gmp_rep));
//     return Res;
// }

const Integer pow(const Integer& n, const int l)
{
  if (l < 0)  return Integer(zero) ;
  if (l == 0) return Integer(one) ;

  unsigned long p = ABS(l) ;
  int is_assg = 0 ;

  Integer res = Integer(one) ;
  Integer puiss  = n ;

  while (p != 0) {
    if (p & 0x1) 
        if (is_assg) 
           res *= puiss ;
        else { 
           is_assg = 1 ; 
           res = puiss ; 
        }
    if ((p >>= 1) != 0) puiss = puiss * puiss ;
  }
  return res ;
}

const Integer pow(const Integer& n, const long l)
{
  if (l < 0)  return Integer(zero) ;
  if (l == 0) return Integer(one) ;

  unsigned long p = ABS(l) ;
  int is_assg = 0 ;

  Integer res = Integer(one) ;
  Integer puiss  = n ;

  while (p != 0) {
    if (p & 0x1) 
        if (is_assg) 
           res *= puiss ;
        else { 
           is_assg = 1 ; 
           res = puiss ; 
        }
    if ((p >>= 1) != 0) puiss = puiss * puiss ;
  }
  return res ;
}
