// ==========================================================================
// file: indeter.C
// author: T. Gautier 
// (c) GIVARO Team
// date: 1994
// version: 1.0
// Description:
// Bugs:
// ==========================================================================

#include <iostream.h>
#include <string.h>
#include "indeter.h"

Indeter::Indeter (const char* s)
{
  int len = strlen(s) ;
  name = new char[len+1] ;
  if (len !=0) strcpy(name,s) ;
  else name[0] = '\0' ;
  refcount = new Counter(1) ;
}

Indeter::Indeter(const Indeter& s)
{
  name = s.name ;
  refcount = s.refcount ;
  refcount->incr() ;
}

Indeter::~Indeter()
{
  if (refcount->decr() ==0) 
  {
    delete [] name ;
    delete refcount ;
  }
}

Indeter& Indeter::logcpy(const Indeter& s) 
{
  this->~Indeter() ; 
  name = s.name ;
  refcount = s.refcount ;
  refcount->incr() ;
  return *this ;
}


Indeter& Indeter::operator=( const Indeter& s )
{
  this->~Indeter() ; 
  int len = strlen(s.name) ;
  name = new char[len+1] ;
  strcpy(name,s.name) ;
  refcount = new Counter(1) ;
  return *this ;
}


int Indeter::compare(const Indeter& b)  const
{ 
  return strcmp(name,b.name) ; 
}


ostream& operator<< (ostream &o, const Indeter &s)
   { return o.operator << (s.name) ; }
istream& operator>> (istream &o, Indeter &s)
   { return o >> s.name ; }


