#ifndef _GIVRANDOM_H_
#define _GIVRANDOM_H_

// ==========================================================================
// file: random.h 
// Time-stamp: <23 Jun 99 19:09:23 Jean-Guillaume.Dumas@imag.fr>
// (c) Givaro Team
// ==========================================================================

template<class TT> TT& NONZEROGIVRANDOM(TT& a) {
    TT tmp;
    do
        tmp = TT(lrand48());
    while (iszero(tmp));
    return a = tmp ;
};

template<class TT> TT& GIVRANDOM(TT& a) {
    return a = TT(lrand48());
};

template<class TT,class M> TT& GIVRANDOM(TT& a, M MOD) {
    return a = TT(lrand48() % MOD);
};


/*
#include <gfq.h>

template<class TT> void NONZEROGIVRANDOM(Gfq<TT>& a) {
    TT tmp;
    do 
        tmp = TT(lrand48()) % Gfq<TT>::_q;
    while (iszero(tmp));
    a.setRep( (tmp<0?tmp+Gfq<TT>::_q:tmp) );
};

template<class TT> void GIVRANDOM(Gfq<TT>& a) {
    TT tmp(lrand48() % Gfq<TT>::_q) ;
    a.setRep( (tmp<0?tmp+Gfq<TT>::_q:tmp) );
};
*/

#endif
